/** @file treekin_cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef TREEKIN_CMDLINE_H
#define TREEKIN_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "treekin"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "treekin"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int absorb_arg;	/**< @brief Make a state absorbing.  */
  char * absorb_orig;	/**< @brief Make a state absorbing original value given at command line.  */
  const char *absorb_help; /**< @brief Make a state absorbing help description.  */
  char * method_arg;	/**< @brief Select method to build transition matrix:
  A ==> Arrhenius-like kinetics
  
  I ==> use input as a rate matrix (default='I').  */
  char * method_orig;	/**< @brief Select method to build transition matrix:
  A ==> Arrhenius-like kinetics
  
  I ==> use input as a rate matrix original value given at command line.  */
  const char *method_help; /**< @brief Select method to build transition matrix:
  A ==> Arrhenius-like kinetics
  
  I ==> use input as a rate matrix help description.  */
  char * num_err_arg;	/**< @brief Specify how to treat issues with numerical errors in probability:
  I ==> Ignore
  H ==> Halt the program
  R ==> Rescale the probability (default='H').  */
  char * num_err_orig;	/**< @brief Specify how to treat issues with numerical errors in probability:
  I ==> Ignore
  H ==> Halt the program
  R ==> Rescale the probability original value given at command line.  */
  const char *num_err_help; /**< @brief Specify how to treat issues with numerical errors in probability:
  I ==> Ignore
  H ==> Halt the program
  R ==> Rescale the probability help description.  */
  double t0_arg;	/**< @brief Start time (default='0.1').  */
  char * t0_orig;	/**< @brief Start time original value given at command line.  */
  const char *t0_help; /**< @brief Start time help description.  */
  double t8_arg;	/**< @brief Stop time (default='1E12').  */
  char * t8_orig;	/**< @brief Stop time original value given at command line.  */
  const char *t8_help; /**< @brief Stop time help description.  */
  double Temp_arg;	/**< @brief Temperature in Celsius (default='37.0').  */
  char * Temp_orig;	/**< @brief Temperature in Celsius original value given at command line.  */
  const char *Temp_help; /**< @brief Temperature in Celsius help description.  */
  int nstates_arg;	/**< @brief Read only first <int> states (assume quasi-stationary distribution (derivation of others is = 0)).  */
  char * nstates_orig;	/**< @brief Read only first <int> states (assume quasi-stationary distribution (derivation of others is = 0)) original value given at command line.  */
  const char *nstates_help; /**< @brief Read only first <int> states (assume quasi-stationary distribution (derivation of others is = 0)) help description.  */
  char ** p0_arg;	/**< @brief Set initial population of state <int> to <double>
  Can be given multiple times
  (NOTE: sum of <double> must equal 1)
  (example: \"--p0 2=1.0\" - state 2 has initial population 100 percent).  */
  char ** p0_orig;	/**< @brief Set initial population of state <int> to <double>
  Can be given multiple times
  (NOTE: sum of <double> must equal 1)
  (example: \"--p0 2=1.0\" - state 2 has initial population 100 percent) original value given at command line.  */
  unsigned int p0_min; /**< @brief Set initial population of state <int> to <double>
  Can be given multiple times
  (NOTE: sum of <double> must equal 1)
  (example: \"--p0 2=1.0\" - state 2 has initial population 100 percent)'s minimum occurreces */
  unsigned int p0_max; /**< @brief Set initial population of state <int> to <double>
  Can be given multiple times
  (NOTE: sum of <double> must equal 1)
  (example: \"--p0 2=1.0\" - state 2 has initial population 100 percent)'s maximum occurreces */
  const char *p0_help; /**< @brief Set initial population of state <int> to <double>
  Can be given multiple times
  (NOTE: sum of <double> must equal 1)
  (example: \"--p0 2=1.0\" - state 2 has initial population 100 percent) help description.  */
  double tinc_arg;	/**< @brief Time scaling factor (for log time-scale) (default='1.02').  */
  char * tinc_orig;	/**< @brief Time scaling factor (for log time-scale) original value given at command line.  */
  const char *tinc_help; /**< @brief Time scaling factor (for log time-scale) help description.  */
  int degeneracy_flag;	/**< @brief Consider degeneracy in transition rates (default=off).  */
  const char *degeneracy_help; /**< @brief Consider degeneracy in transition rates help description.  */
  int exponent_flag;	/**< @brief Use matrix-expontent routines, rather than diagonalization (default=off).  */
  const char *exponent_help; /**< @brief Use matrix-expontent routines, rather than diagonalization help description.  */
  int dumpU_flag;	/**< @brief Dump transition matrix U to file mx.txt (and to binary mx.bin - not fixed yet) (default=off).  */
  const char *dumpU_help; /**< @brief Dump transition matrix U to file mx.txt (and to binary mx.bin - not fixed yet) help description.  */
  int mathematicamatrix_flag;	/**< @brief Dump transition matrix U to Mathematica-readable file mxMat.txt (default=off).  */
  const char *mathematicamatrix_help; /**< @brief Dump transition matrix U to Mathematica-readable file mxMat.txt help description.  */
  int bin_flag;	/**< @brief Assume binary rates input (default=off).  */
  const char *bin_help; /**< @brief Assume binary rates input help description.  */
  char * bar_arg;	/**< @brief Read barriers input from file instead of standard input. Required in case \"-m I\" (rates kinetics) AND \"-a\" (absorbing state) is given.  */
  char * bar_orig;	/**< @brief Read barriers input from file instead of standard input. Required in case \"-m I\" (rates kinetics) AND \"-a\" (absorbing state) is given original value given at command line.  */
  const char *bar_help; /**< @brief Read barriers input from file instead of standard input. Required in case \"-m I\" (rates kinetics) AND \"-a\" (absorbing state) is given help description.  */
  char * fpt_arg;	/**< @brief Compute first passage times (FPT). Arguments:
  all => compute all FPT (slow)
  <num> - compute FPT to state <num> from all states.  */
  char * fpt_orig;	/**< @brief Compute first passage times (FPT). Arguments:
  all => compute all FPT (slow)
  <num> - compute FPT to state <num> from all states original value given at command line.  */
  const char *fpt_help; /**< @brief Compute first passage times (FPT). Arguments:
  all => compute all FPT (slow)
  <num> - compute FPT to state <num> from all states help description.  */
  int recoverE_flag;	/**< @brief Recover from pre-ccomputes eigenvalues and eigenvectors (default=off).  */
  const char *recoverE_help; /**< @brief Recover from pre-ccomputes eigenvalues and eigenvectors help description.  */
  int dumpE_flag;	/**< @brief Dump eigenvalues and eigenvectors to a binary recovery file and continue with iteration (default=off).  */
  const char *dumpE_help; /**< @brief Dump eigenvalues and eigenvectors to a binary recovery file and continue with iteration help description.  */
  int dumpX_flag;	/**< @brief Dump eigenvalues to ASCII file and exit (do not iterate) (default=off).  */
  const char *dumpX_help; /**< @brief Dump eigenvalues to ASCII file and exit (do not iterate) help description.  */
  int info_flag;	/**< @brief Show settings (default=off).  */
  const char *info_help; /**< @brief Show settings help description.  */
  char * ratesfile_arg;	/**< @brief Read transition rates from file instead of standard input..  */
  char * ratesfile_orig;	/**< @brief Read transition rates from file instead of standard input. original value given at command line.  */
  const char *ratesfile_help; /**< @brief Read transition rates from file instead of standard input. help description.  */
  int verbose_flag;	/**< @brief Verbose output (default=off).  */
  const char *verbose_help; /**< @brief Verbose output help description.  */
  int quiet_flag;	/**< @brief Be silent (do not print out the output) (default=off).  */
  const char *quiet_help; /**< @brief Be silent (do not print out the output) help description.  */
  char * fptfile_arg;	/**< @brief Filename of FPT file (provided -t option given).  */
  char * fptfile_orig;	/**< @brief Filename of FPT file (provided -t option given) original value given at command line.  */
  const char *fptfile_help; /**< @brief Filename of FPT file (provided -t option given) help description.  */
  char * visualize_arg;	/**< @brief Filename where to print a visualization of rate graph (without file subscript, two files will be generated: .dot and .eps with text and visual representation of graph).  */
  char * visualize_orig;	/**< @brief Filename where to print a visualization of rate graph (without file subscript, two files will be generated: .dot and .eps with text and visual representation of graph) original value given at command line.  */
  const char *visualize_help; /**< @brief Filename where to print a visualization of rate graph (without file subscript, two files will be generated: .dot and .eps with text and visual representation of graph) help description.  */
  int just_shorten_flag;	/**< @brief Do not diagonalize and iterate, just shorten input (meaningfull only with -n X option or -fpt option or --visualize option) (default=off).  */
  const char *just_shorten_help; /**< @brief Do not diagonalize and iterate, just shorten input (meaningfull only with -n X option or -fpt option or --visualize option) help description.  */
  int max_decrease_arg;	/**< @brief Maximal decrease in dimension in one step (default='1000000').  */
  char * max_decrease_orig;	/**< @brief Maximal decrease in dimension in one step original value given at command line.  */
  const char *max_decrease_help; /**< @brief Maximal decrease in dimension in one step help description.  */
  double feps_arg;	/**< @brief Machine precision used by LAPACK routines (and matrix aritmetic) -- if set to negative number, the lapack suggested value is used (2*DLAMCH(\"S\") ) (default='1E-15').  */
  char * feps_orig;	/**< @brief Machine precision used by LAPACK routines (and matrix aritmetic) -- if set to negative number, the lapack suggested value is used (2*DLAMCH(\"S\") ) original value given at command line.  */
  const char *feps_help; /**< @brief Machine precision used by LAPACK routines (and matrix aritmetic) -- if set to negative number, the lapack suggested value is used (2*DLAMCH(\"S\") ) help description.  */
  int useplusI_flag;	/**< @brief Use old treekin computation where we add identity matrix to transition matrix. Sometimes less precise (maybe sometimes also more precise), in normal case it should not affect results at all. (default=off).  */
  const char *useplusI_help; /**< @brief Use old treekin computation where we add identity matrix to transition matrix. Sometimes less precise (maybe sometimes also more precise), in normal case it should not affect results at all. help description.  */
  double minimal_rate_arg;	/**< @brief Rescale all rates to be higher than the minimal rate using formula  \"rate -> rate^(ln(desired_minimal_rate)/ln(minimal_rate))\", where desired_minimal_rate is from input, minimal_rate is the lowest from all rates in rate matrix..  */
  char * minimal_rate_orig;	/**< @brief Rescale all rates to be higher than the minimal rate using formula  \"rate -> rate^(ln(desired_minimal_rate)/ln(minimal_rate))\", where desired_minimal_rate is from input, minimal_rate is the lowest from all rates in rate matrix. original value given at command line.  */
  const char *minimal_rate_help; /**< @brief Rescale all rates to be higher than the minimal rate using formula  \"rate -> rate^(ln(desired_minimal_rate)/ln(minimal_rate))\", where desired_minimal_rate is from input, minimal_rate is the lowest from all rates in rate matrix. help description.  */
  double hard_rescale_arg;	/**< @brief Rescale all rates by a hard exponent (usually 0.0<HR<1.0). Formula: \"rate -> rate^(hard-rescale)\". Overrides --minimal-rate argument..  */
  char * hard_rescale_orig;	/**< @brief Rescale all rates by a hard exponent (usually 0.0<HR<1.0). Formula: \"rate -> rate^(hard-rescale)\". Overrides --minimal-rate argument. original value given at command line.  */
  const char *hard_rescale_help; /**< @brief Rescale all rates by a hard exponent (usually 0.0<HR<1.0). Formula: \"rate -> rate^(hard-rescale)\". Overrides --minimal-rate argument. help description.  */
  char * equil_file_arg;	/**< @brief Write equilibrium distribution into a file..  */
  char * equil_file_orig;	/**< @brief Write equilibrium distribution into a file. original value given at command line.  */
  const char *equil_file_help; /**< @brief Write equilibrium distribution into a file. help description.  */
  double times_arg;	/**< @brief Multiply rates with a constant number..  */
  char * times_orig;	/**< @brief Multiply rates with a constant number. original value given at command line.  */
  const char *times_help; /**< @brief Multiply rates with a constant number. help description.  */
  int warnings_flag;	/**< @brief Turn all the warnings about underflow on. (default=off).  */
  const char *warnings_help; /**< @brief Turn all the warnings about underflow on. help description.  */
  int mpack_precision_arg;	/**< @brief Number of bits for the eigenvalue method of the mpack library. A value > 64 is recommended, otherwise the standard lapack method would be faster..  */
  char * mpack_precision_orig;	/**< @brief Number of bits for the eigenvalue method of the mpack library. A value > 64 is recommended, otherwise the standard lapack method would be faster. original value given at command line.  */
  const char *mpack_precision_help; /**< @brief Number of bits for the eigenvalue method of the mpack library. A value > 64 is recommended, otherwise the standard lapack method would be faster. help description.  */
  char * mpack_method_arg;	/**< @brief The mpack precision method. \"LD\", \"QD\", \"DD\", \"DOUBLE\", \"GMP\", \"MPFR\", \"FLOAT128\". You have to set mpack-precision if \"GMP\", \"MPFR\" is selected! \"LD\" is the standard long double with 80 bit..  */
  char * mpack_method_orig;	/**< @brief The mpack precision method. \"LD\", \"QD\", \"DD\", \"DOUBLE\", \"GMP\", \"MPFR\", \"FLOAT128\". You have to set mpack-precision if \"GMP\", \"MPFR\" is selected! \"LD\" is the standard long double with 80 bit. original value given at command line.  */
  const char *mpack_method_help; /**< @brief The mpack precision method. \"LD\", \"QD\", \"DD\", \"DOUBLE\", \"GMP\", \"MPFR\", \"FLOAT128\". You have to set mpack-precision if \"GMP\", \"MPFR\" is selected! \"LD\" is the standard long double with 80 bit. help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int absorb_given ;	/**< @brief Whether absorb was given.  */
  unsigned int method_given ;	/**< @brief Whether method was given.  */
  unsigned int num_err_given ;	/**< @brief Whether num-err was given.  */
  unsigned int t0_given ;	/**< @brief Whether t0 was given.  */
  unsigned int t8_given ;	/**< @brief Whether t8 was given.  */
  unsigned int Temp_given ;	/**< @brief Whether Temp was given.  */
  unsigned int nstates_given ;	/**< @brief Whether nstates was given.  */
  unsigned int p0_given ;	/**< @brief Whether p0 was given.  */
  unsigned int tinc_given ;	/**< @brief Whether tinc was given.  */
  unsigned int degeneracy_given ;	/**< @brief Whether degeneracy was given.  */
  unsigned int exponent_given ;	/**< @brief Whether exponent was given.  */
  unsigned int dumpU_given ;	/**< @brief Whether dumpU was given.  */
  unsigned int mathematicamatrix_given ;	/**< @brief Whether mathematicamatrix was given.  */
  unsigned int bin_given ;	/**< @brief Whether bin was given.  */
  unsigned int bar_given ;	/**< @brief Whether bar was given.  */
  unsigned int fpt_given ;	/**< @brief Whether fpt was given.  */
  unsigned int recoverE_given ;	/**< @brief Whether recoverE was given.  */
  unsigned int dumpE_given ;	/**< @brief Whether dumpE was given.  */
  unsigned int dumpX_given ;	/**< @brief Whether dumpX was given.  */
  unsigned int info_given ;	/**< @brief Whether info was given.  */
  unsigned int ratesfile_given ;	/**< @brief Whether ratesfile was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */
  unsigned int quiet_given ;	/**< @brief Whether quiet was given.  */
  unsigned int fptfile_given ;	/**< @brief Whether fptfile was given.  */
  unsigned int visualize_given ;	/**< @brief Whether visualize was given.  */
  unsigned int just_shorten_given ;	/**< @brief Whether just-shorten was given.  */
  unsigned int max_decrease_given ;	/**< @brief Whether max-decrease was given.  */
  unsigned int feps_given ;	/**< @brief Whether feps was given.  */
  unsigned int useplusI_given ;	/**< @brief Whether useplusI was given.  */
  unsigned int minimal_rate_given ;	/**< @brief Whether minimal-rate was given.  */
  unsigned int hard_rescale_given ;	/**< @brief Whether hard-rescale was given.  */
  unsigned int equil_file_given ;	/**< @brief Whether equil-file was given.  */
  unsigned int times_given ;	/**< @brief Whether times was given.  */
  unsigned int warnings_given ;	/**< @brief Whether warnings was given.  */
  unsigned int mpack_precision_given ;	/**< @brief Whether mpack-precision was given.  */
  unsigned int mpack_method_given ;	/**< @brief Whether mpack-method was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);

extern const char *cmdline_parser_method_values[];  /**< @brief Possible values for method. */
extern const char *cmdline_parser_num_err_values[];  /**< @brief Possible values for num-err. */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* TREEKIN_CMDLINE_H */
